/* -- THIS FILE IS GENERATED - DO NOT EDIT *//* -*- Mode: C; c-basic-offset: 4 -*- */

#define PY_SSIZE_T_CLEAN
#include <Python.h>




#if PY_VERSION_HEX < 0x02050000
typedef int Py_ssize_t;
#define PY_SSIZE_T_MAX INT_MAX
#define PY_SSIZE_T_MIN INT_MIN
typedef inquiry lenfunc;
typedef intargfunc ssizeargfunc;
typedef intobjargproc ssizeobjargproc;
#endif


#line 23 "mime/hildonmime.override"
#define NO_IMPORT_PYGOBJECT
#include <pygobject.h>

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#include <libintl.h>

#include <glib-object.h>
#include <hildon-mime.h>

#include "hildonmime-types.h"

typedef PyObject *(*list_item_converter)(gpointer item);
typedef gpointer *(*pylist_item_converter)(PyObject *obj);

static PyObject *glist_to_pylist(GList *list, list_item_converter func)
{
    PyObject *pylist;
    gint size, i;
    GList *tmp = list;

    size = g_list_length(list);

    pylist = PyList_New(size);

    for (i = 0; i < size; i++) {
        /* Create each object */
        PyObject *item;

        item = func(tmp->data);
        PyList_SET_ITEM(pylist, i, item);
        tmp = tmp->next;
    }
    
    return pylist;
}

#line 59 "mime/hildonmime.c"


/* ---------- types from other modules ---------- */
static PyTypeObject *_PyGObject_Type;
#define PyGObject_Type (*_PyGObject_Type)


/* ---------- forward type declarations ---------- */

#line 69 "mime/hildonmime.c"



/* ----------- functions ----------- */

static PyObject *
_wrap_hildon_mime_get_category_for_mime_type(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "mime_type", NULL };
    char *mime_type;
    guint ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"s:get_category_for_mime_type", kwlist, &mime_type))
        return NULL;
    
    ret = hildon_mime_get_category_for_mime_type(mime_type);
    
    return pyg_flags_from_gtype(HILDON_MIME_TYPE_CATEGORY, ret);
}

#line 70 "mime/hildonmime.override"
static PyObject *
_wrap_hildon_mime_get_mime_types_for_category(PyObject *self,
                                              PyObject *args,
                                              PyObject *kwargs)
{
    static char *kwlist[] = {"category", NULL};
    PyObject *pyenum;
    PyObject *pylist;
    HildonMimeCategory category;
    GList *mime_types;


    if (!PyArg_ParseTupleAndKeywords(args, kwargs,
                                     "O:get_mime_types_for_category",
                                     kwlist, &pyenum))
        return NULL;
    
    if (pyg_enum_get_value(HILDON_MIME_TYPE_CATEGORY, pyenum,
                           (gpointer)&category))
        return NULL;

    mime_types = hildon_mime_get_mime_types_for_category(category);

    pylist = glist_to_pylist(mime_types,
                            (list_item_converter)PyString_FromString);

    if (mime_types)
        hildon_mime_types_list_free(mime_types);

    return pylist;
}
#line 122 "mime/hildonmime.c"


static PyObject *
_wrap_hildon_mime_get_category_name(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "category", NULL };
    HildonMimeCategory category;
    PyObject *py_category = NULL;
    const gchar *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O:get_category_name", kwlist, &py_category))
        return NULL;
    if (pyg_flags_get_value(HILDON_MIME_TYPE_CATEGORY, py_category, (gpointer)&category))
        return NULL;
    
    ret = hildon_mime_get_category_name(category);
    
    if (ret)
        return PyString_FromString(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_hildon_mime_get_category_from_name(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "category", NULL };
    char *category;
    guint ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"s:get_category_from_name", kwlist, &category))
        return NULL;
    
    ret = hildon_mime_get_category_from_name(category);
    
    return pyg_flags_from_gtype(HILDON_MIME_TYPE_CATEGORY, ret);
}

const PyMethodDef pyhildonmime_functions[] = {
    { "get_category_for_mime_type", (PyCFunction)_wrap_hildon_mime_get_category_for_mime_type, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_mime_types_for_category", (PyCFunction)_wrap_hildon_mime_get_mime_types_for_category, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_category_name", (PyCFunction)_wrap_hildon_mime_get_category_name, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_category_from_name", (PyCFunction)_wrap_hildon_mime_get_category_from_name, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { NULL, NULL, 0, NULL }
};


/* ----------- enums and flags ----------- */

void
pyhildonmime_add_constants(PyObject *module, const gchar *strip_prefix)
{
#ifdef VERSION
    PyModule_AddStringConstant(module, "__version__", VERSION);
#endif
  pyg_flags_add(module, "MimeCategory", strip_prefix, HILDON_MIME_TYPE_CATEGORY);

  if (PyErr_Occurred())
    PyErr_Print();
}

/* initialise stuff extension classes */
void
pyhildonmime_register_classes(PyObject *d)
{
    PyObject *module;

    if ((module = PyImport_ImportModule("gobject")) != NULL) {
        _PyGObject_Type = (PyTypeObject *)PyObject_GetAttrString(module, "GObject");
        if (_PyGObject_Type == NULL) {
            PyErr_SetString(PyExc_ImportError,
                "cannot import name GObject from gobject");
            return ;
        }
    } else {
        PyErr_SetString(PyExc_ImportError,
            "could not import gobject");
        return ;
    }


#line 208 "mime/hildonmime.c"
}
